//-------------------------------------------------------------------------------------------------
// Image.hpp (engine)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
// 
// An Image is a generic representation of a 2d array of pixel data.
//	So far the Image class supports loading of the following formats:
//		- (none)
//-------------------------------------------------------------------------------------------------
#ifndef _include_Image_
#define _include_Image_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "engineCommon.hpp"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		Image
//
///////////////////////////////////////////////////////////////////////////////////////////////////
class Image
{
private:
	static const dword_t TEXNUM_UNREGISTERED;
	static byte_t	_primerTGA_correct[ 12 ];	// the first 12 bytes of a valid TGA file

	word_t			_width;						// number of pixels wide
	word_t			_height;					// number of pixels high
	byte_t			_bpp;						// bits per pixel; usually 24 or 32
	byte_t*			_pixelData;					// buffer containing ( _width * _height * _bpp / 8 ) bytes
	GLenum			_internalFormat;			// format specification for how opengl should store the image internally
	GLenum			_bufferFormat;				// format specification for how opengl should read <_pixelData>
	std::string		_filePath;					// image file name path that was used for construction

	void _LoadFromFile( const std::string& filePath );
	void _LoadTGAFromFile( FILE* file );

public:
	Image::Image( const std::string& filePath );
	~Image();

	byte_t*			getPixelData( void )		{ return _pixelData ; }
	word_t			getWidth( void )			{ return _width ; }
	word_t			getHeight( void )			{ return _height ; }

	friend class Texture;
};




#endif // _include_Image_
