//-------------------------------------------------------------------------------------------------
// Animation.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_Animation_
#define _include_Animation_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "gameCommon.hpp"
//typedef Texture Animation;

///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		Animation
// 
///////////////////////////////////////////////////////////////////////////////////////////////////

class Animation
{
private:
public:
	/// Constructors / destructors
	Animation( const std::string& filePath, float aFrate=10.0f, const Vector2& aScale=Vector2::ONE, float aRotDeg=0 ); // constructor
	~Animation(); // destructor

	/// Public methods
	void Draw( const Vector2& screenCenterCoordinates, const Vector2& aScale=Vector2::ONE, float aRotDeg=0, int aDrawFrame=-666  );
	int GetLoop();
	void ResetAnim();

	float frate;			// frame rate of the animation
	int framenum;			// number of frames in the animation
	int size;				// size of the animation in screen coord 32 = 32x32, 64 = 64x64, etc...
	int totalframes;		// total number of frames in the animation set
	int nexttick;			// the time for the next tick.
	Vector2 scale;			// scale of image
	float rotdeg;			// rotation in degrees
	double starttime;
	Texture* a_texture;		// The actual texture
	int loopcount;		// Number of loop iterations that have occured


};

#endif // _include_Animation_

//-------------------------------------------------------------------------------------------------
// Externally viewable globals
//-------------------------------------------------------------------------------------------------
//extern TheGame* theGame;

/*
struct Baby
{
//	Animation*	anim_idle;
//	Animation*	anim_crawl;
//	Animation*	anim_woundedCrawl;
};






{
	Vector2 center( 30.0f, 50.0f );
	anim_idle->Draw( center );
}



{
	anim_idle = new Animation( "BabyAnim_Idle.tga" );
	anim_idle = new Animation( "BabyAnim_Crawl.tga" );
	anim_idle = new Animation( "BabyAnim_woundedCrawl.tga" );
}



Animation::Animation( const char* fileName )
{
	m_texture = new Texture( fileName );
	width
	height

	numberOfFrames
	currentFrame
}


Animation::Draw( const Vector2& screenCenterCoordinates )
{
	/// figure out what frame we're on

	/// figure out what texture coordinates are needed for that frame

	/// draw using the renderer and texture coordinates
	theRenderer.DrawTexturedRectCentered( m_texture, screenCenterCoordinates );
}


*/