//-------------------------------------------------------------------------------------------------
// Firework.hpp
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_Firework_
#define _include_Firework_

typedef struct _finddata_t FileData;


enum KeyType
{
	KEYTYPE_INVALID = -1,
//	KEYTYPE_INT,
//	KEYTYPE_FLOAT,
//	KEYTYPE_INT_RANGE,
	KEYTYPE_FLOAT_RANGE,
	KEYTYPE_STRING,
	NUM_KEYTYPES,
};


struct KeyTypeTableEntry
{
	const char*		keyName;
	KeyType			keyType;
};




//-------------------------------------------------------------------------------------------------
// 
//		Firework
// 
//-------------------------------------------------------------------------------------------------
struct Firework
{
	static const char* SEARCH_FILE_PATTERN;
	static std::vector<Firework> m_fireworkDefinitions;

	std::string m_fireworkName;
	Vector2 fuseSecondsMinMax;
	Vector2 durationSecondsMinMax;
	Vector2 attractValueMinMax;
	Vector2 attractRadiusMinMax;
	Vector2 blastForceMinMax;
	Vector2 blastDamageMinMax;
	Vector2 blastRadiusMinMax;
	std::string iconImageString;
	std::string projectileImageString;

	Firework();
	~Firework();

	static void ParseAllFireworkFiles();
	static int ParseFireworkFile( const FileData& fileData );
	static int ParseFireworkBuffer( const char* buffer );
	const char* ParseFireworkDefinition( const char* read );
	const char* ParseFireworkDefinitionBlock( const char* read );
	const char* ParseKeyValueLine( const char* read );
	const char* ParseValueForKey( const char* read, const char* keyName );
	KeyType GetKeyTypeForKeyName( const char* keyName );
	const char* ParseValueForKey_FloatRange( const char* read, const char* keyName );
	const char* ParseValueForKey_String( const char* read, const char* keyName );
	const char* ParseFloatValue( const char* read, float& value );
	void SetDataMember( const char* keyName, float min, float max );
	void SetDataMember( const char* keyName, const char* stringValue );
	const char* ParseFloatRange( const char* read, float& min, float& max );

};



#endif // _include_Firework_
