//-------------------------------------------------------------------------------------------------
// Mine.hpp
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "Animation.hpp"


struct Mine
{
	static const float MINE_RADIUS;
	static const char* MINE_ANIM_NAME_IDLE;
	static std::vector<Mine*> mineList;

	Vector2			position;
	Animation*		anim_idle;

	/// Construction / deconstruction
	Mine( const Vector2& startPosition );
	~Mine();

	/// Updating, drawing, etc.
	static void		UpdateAll();
	void			Update();

	static void		DrawAll();
	void			Draw();

	static Mine*	FindFirstMineThatCollidesWithPoint( Vector2& position, float radius );
	bool			Collide( Vector2& position, float radius );
};

