//-------------------------------------------------------------------------------------------------
// TheGame.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "TheGame.hpp"
#include "TheMap.hpp"


//-------------------------------------------------------------------------------------------------
// Globals
//-------------------------------------------------------------------------------------------------
TheGame* theGame = NULL;


//-------------------------------------------------------------------------------------------------
// Destructor()
//-------------------------------------------------------------------------------------------------
TheGame::~TheGame()
{
}


//-------------------------------------------------------------------------------------------------
// Constructor
//-------------------------------------------------------------------------------------------------
TheGame::TheGame()
{
}


//-------------------------------------------------------------------------------------------------
// PreInit
//-------------------------------------------------------------------------------------------------
void TheGame::PreInit()
{
	/// Assign application name
	theApplication.SetName( "Meat My Baby" );

	/// Choose a video mode
//	theVideoSystem.SetDefaultVidModeProperties( 1024, 768, 32, 85, TheVideoSystem::VIDMODE_FLAG_FULLSCREEN );
	theVideoSystem.SetDefaultVidModeProperties( 1024, 768, 32, 85, 0 );
}


//-------------------------------------------------------------------------------------------------
// PostInit
//-------------------------------------------------------------------------------------------------
void TheGame::PostInit()
{
	theRenderer.ShowFpsToggle();

	theMap.loadLevel( "Level02" );
}


//-------------------------------------------------------------------------------------------------
// RunFrame
//-------------------------------------------------------------------------------------------------
void TheGame::RunFrame()
{
	/// Set up the drawing context
	SetUpCoordinateSystem();

	if ( Baby::BabiesAllDead() )
	{
		theRenderer.XYPrintf( 1024.0f/2.0f, 768.0f/2.0f, "YOU LOSE!" );
	}
	else
	{
		/// Process input, update entities, run game logic
		UpdateEverything();
	}

	/// Render the scene
	DrawEverything();
}


//-------------------------------------------------------------------------------------------------
// OnKeyDown
//-------------------------------------------------------------------------------------------------
void TheGame::OnKeyDown( const byte_t key )
{
	if( key == VK_ESCAPE )
	{
		theApplication.RequestShutdown();
	}
	else if( key == VK_F11 )
	{
		theRenderer.ShowFpsToggle();
	}
	else if( key == VK_TILDE )
	{
		theRenderer.ShowConsoleToggle();
	}
}


//-------------------------------------------------------------------------------------------------
// OnKeyUp
//-------------------------------------------------------------------------------------------------
void TheGame::OnKeyUp( const byte_t key )
{
}



