//-------------------------------------------------------------------------------------------------
// TheGame.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_TheGame_
#define _include_TheGame_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "gameCommon.hpp"
#include "Animation.hpp"
#include "Baby.hpp"
#include "Firework.hpp"
#include "Mine.hpp"
#include "TheMap.hpp"
#include "Tower.hpp"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		TheGame
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class TheGame
{
private:
public:
	/// Constructors / destructors
	TheGame(); // default constructor
	~TheGame(); // destructor

	/// from TheGame.cpp
	void PreInit();
	void PostInit();
	void RunFrame();

	void OnKeyDown( const byte_t key );
	void OnKeyUp( const byte_t key );

	/// from TheGame_Update.cpp
	void UpdateEverything();

	/// from TheGame_Draw.cpp
	void SetUpCoordinateSystem();
	void DrawEverything();
};


//-------------------------------------------------------------------------------------------------
// Externally viewable globals
//-------------------------------------------------------------------------------------------------
extern TheGame* theGame;


#endif // _include_TheGame_
