//-------------------------------------------------------------------------------------------------
// TheGame_Draw.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "TheGame.hpp"
#include "TheMap.hpp"



//-------------------------------------------------------------------------------------------------
// SetUpCoordinateSystem
// 
// Set up the drawing context
//-------------------------------------------------------------------------------------------------
void TheGame::SetUpCoordinateSystem()
{
	/// Get the size and center of the current video mode
	Vector2 screenSize( (float) theVideoSystem.GetCurrentVidModeWidth(), (float) theVideoSystem.GetCurrentVidModeHeight() );
	Vector2 screenCenter( screenSize * 0.5f );

	/// Set up a 2d drawing coordinate system with 0.0 at the bottom-left
	theRenderer.SetCoordinateSystem( Vector2::ZERO, screenSize );
}


//-------------------------------------------------------------------------------------------------
// DrawEverything
// 
// Render the scene
//-------------------------------------------------------------------------------------------------
void TheGame::DrawEverything()
{
	/// Draw the map background image
	theMap.draw();

	/// Draw babies, mines, and other entities
	Mine::DrawAll();
	Baby::DrawAll();
	Tower::DrawAll();
}





